Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFormEditorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFormEditorWidget.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFormEditorWidget.cpp	(revision 79814)
@@ -1398,4 +1398,9 @@
 }
 
+void UIFormEditorWidget::makeSureEditorDataCommitted()
+{
+    m_pTableView->makeSureEditorDataCommitted();
+}
+
 bool UIFormEditorWidget::eventFilter(QObject *pObject, QEvent *pEvent)
 {
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFormEditorWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFormEditorWidget.h	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFormEditorWidget.h	(revision 79814)
@@ -44,4 +44,7 @@
     void setVirtualSystemDescriptionForm(const CVirtualSystemDescriptionForm &comForm);
 
+    /** Makes sure current editor data committed. */
+    void makeSureEditorDataCommitted();
+
 protected:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 79814)
@@ -215,4 +215,7 @@
     if (fIsFormatCloudOne)
     {
+        /* Make sure table has own data committed: */
+        m_pFormEditor->makeSureEditorDataCommitted();
+
         /* Check whether we have proper VSD form: */
         CVirtualSystemDescriptionForm comForm = fieldImp("vsdExportForm").value<CVirtualSystemDescriptionForm>();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 79814)
@@ -629,4 +629,7 @@
     if (fIsFormatCloudOne)
     {
+        /* Make sure table has own data committed: */
+        m_pFormEditor->makeSureEditorDataCommitted();
+
         /* Check whether we have proper VSD form: */
         CVirtualSystemDescriptionForm comForm = fieldImp("vsdExportForm").value<CVirtualSystemDescriptionForm>();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic2.cpp	(revision 79814)
@@ -286,4 +286,7 @@
     if (fIsSourceCloudOne)
     {
+        /* Make sure table has own data committed: */
+        m_pFormEditor->makeSureEditorDataCommitted();
+
         /* Check whether we have proper VSD form: */
         CVirtualSystemDescriptionForm comForm = fieldImp("vsdForm").value<CVirtualSystemDescriptionForm>();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageExpert.cpp	(revision 79814)
@@ -383,4 +383,7 @@
     if (fIsSourceCloudOne)
     {
+        /* Make sure table has own data committed: */
+        m_pFormEditor->makeSureEditorDataCommitted();
+
         /* Check whether we have proper VSD form: */
         CVirtualSystemDescriptionForm comForm = fieldImp("vsdForm").value<CVirtualSystemDescriptionForm>();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageBasic2.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageBasic2.cpp	(revision 79814)
@@ -149,4 +149,7 @@
     startProcessing();
 
+    /* Make sure table has own data committed: */
+    m_pFormEditor->makeSureEditorDataCommitted();
+
     /* Check whether we have proper VSD form: */
     CVirtualSystemDescriptionForm comForm = vsdForm();
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 79813)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newcloudvm/UIWizardNewCloudVMPageExpert.cpp	(revision 79814)
@@ -267,4 +267,7 @@
     startProcessing();
 
+    /* Make sure table has own data committed: */
+    m_pFormEditor->makeSureEditorDataCommitted();
+
     /* Check whether we have proper VSD form: */
     CVirtualSystemDescriptionForm comForm = UIWizardNewCloudVMPage1::vsdForm();