Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetails.cpp	(revision 79842)
@@ -65,4 +65,7 @@
                 pMainLayout->addWidget(m_pDetailsView);
             }
+
+            /* Init model: */
+            m_pDetailsModel->init();
         }
     }
@@ -77,6 +80,4 @@
     connect(m_pDetailsModel, &UIDetailsModel::sigRootItemMinimumWidthHintChanged,
             m_pDetailsView, &UIDetailsView::sltMinimumWidthHintChanged);
-    connect(m_pDetailsModel, &UIDetailsModel::sigRootItemMinimumHeightHintChanged,
-            m_pDetailsView, &UIDetailsView::sltMinimumHeightHintChanged);
     connect(m_pDetailsModel, &UIDetailsModel::sigLinkClicked,
             this, &UIDetails::sigLinkClicked);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.cpp	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.cpp	(revision 79842)
@@ -24,4 +24,5 @@
 
 /* GUI includes: */
+#include "UIGraphicsScrollArea.h"
 #include "UIDetailsGroup.h"
 #include "UIDetailsModel.h"
@@ -36,19 +37,27 @@
     : UIDetailsItem(0)
     , m_pBuildStep(0)
+    , m_pScrollArea(0)
     , m_pContainer(0)
     , m_pLayout(0)
     , m_iPreviousMinimumWidthHint(0)
-    , m_iPreviousMinimumHeightHint(0)
-{
-    /* Prepare container: */
-    m_pContainer = new QIGraphicsWidget(this);
-    if (m_pContainer)
-    {
-        /* Prepare layout: */
-        m_pLayout = new QGraphicsLinearLayout(Qt::Vertical, m_pContainer);
-        if (m_pLayout)
+{
+    /* Prepare scroll-area: */
+    m_pScrollArea = new UIGraphicsScrollArea(Qt::Vertical, this);
+    if (m_pScrollArea)
+    {
+        /* Prepare container: */
+        m_pContainer = new QIGraphicsWidget;
+        if (m_pContainer)
         {
-            m_pLayout->setContentsMargins(0, 0, 0, 0);
-            m_pLayout->setSpacing(0);
+            /* Prepare layout: */
+            m_pLayout = new QGraphicsLinearLayout(Qt::Vertical, m_pContainer);
+            if (m_pLayout)
+            {
+                m_pLayout->setContentsMargins(0, 0, 0, 0);
+                m_pLayout->setSpacing(0);
+            }
+
+            /* Assign to scroll-area: */
+            m_pScrollArea->setViewport(m_pContainer);
         }
     }
@@ -102,4 +111,10 @@
 }
 
+void UIDetailsGroup::installEventFilterHelper(QObject *pSource)
+{
+    /* The only object which need's that filter for now is scroll-area: */
+    pSource->installEventFilter(m_pScrollArea);
+}
+
 QList<UIDetailsItem*> UIDetailsGroup::items(UIDetailsItemType enmType /* = UIDetailsItemType_Set */) const
 {
@@ -118,7 +133,7 @@
     UIDetailsView *pView = model()->view();
 
-    /* Adjust children container geometry: */
-    m_pContainer->resize(pView->viewport()->size());
-    m_pContainer->setPos(0, 0);
+    /* Adjust children scroll-area: */
+    m_pScrollArea->resize(pView->size());
+    m_pScrollArea->setPos(0, 0);
 
     /* Layout all the sets: */
@@ -242,12 +257,4 @@
         emit sigMinimumWidthHintChanged(m_iPreviousMinimumWidthHint);
     }
-    /* Group-item should notify details-view if minimum-height-hint was changed: */
-    int iMinimumHeightHint = minimumHeightHint();
-    if (m_iPreviousMinimumHeightHint != iMinimumHeightHint)
-    {
-        /* Save new minimum-height-hint, notify listener: */
-        m_iPreviousMinimumHeightHint = iMinimumHeightHint;
-        emit sigMinimumHeightHintChanged(m_iPreviousMinimumHeightHint);
-    }
 }
 
@@ -257,6 +264,4 @@
     connect(this, SIGNAL(sigMinimumWidthHintChanged(int)),
             model(), SIGNAL(sigRootItemMinimumWidthHintChanged(int)));
-    connect(this, SIGNAL(sigMinimumHeightHintChanged(int)),
-            model(), SIGNAL(sigRootItemMinimumHeightHintChanged(int)));
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.h	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsGroup.h	(revision 79842)
@@ -28,4 +28,5 @@
 class QGraphicsLinearLayout;
 class QGraphicsScene;
+class UIGraphicsScrollArea;
 class UIVirtualMachineItem;
 
@@ -41,6 +42,4 @@
         /** Notifies listeners about @a iMinimumWidthHint changed. */
         void sigMinimumWidthHintChanged(int iMinimumWidthHint);
-        /** Notifies listeners about @a iMinimumHeightHint changed. */
-        void sigMinimumHeightHintChanged(int iMinimumHeightHint);
     /** @} */
 
@@ -63,4 +62,7 @@
         /** Stops currently building group. */
         void stopBuildingGroup();
+
+        /** Installs event-filter for @a pSource object. */
+        virtual void installEventFilterHelper(QObject *pSource) /* override */;
     /** @} */
 
@@ -152,4 +154,6 @@
     /** @name Children stuff.
       * @{ */
+        /** Holds the children scroll-area instance. */
+        UIGraphicsScrollArea  *m_pScrollArea;
         /** Holds the children container instance. */
         QIGraphicsWidget      *m_pContainer;
@@ -166,6 +170,6 @@
     /** @name Layout stuff.
       * @{ */
+        /** Holds previous minimum width hint. */
         int m_iPreviousMinimumWidthHint;
-        int m_iPreviousMinimumHeightHint;
     /** @} */
 };
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.h	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsItem.h	(revision 79842)
@@ -89,4 +89,8 @@
         /** Returns the description of the item. */
         virtual QString description() const = 0;
+
+        /** Installs event-filter for @a pSource object.
+          * @note  Base-class implementation does nothing. */
+        virtual void installEventFilterHelper(QObject *pSource) { Q_UNUSED(pSource); }
     /** @} */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsModel.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsModel.cpp	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsModel.cpp	(revision 79842)
@@ -56,4 +56,11 @@
 }
 
+void UIDetailsModel::init()
+{
+    /* Install root as event-filter for scene view,
+     * we need QEvent::Scroll events from it: */
+    root()->installEventFilterHelper(view());
+}
+
 QGraphicsScene *UIDetailsModel::scene() const
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsModel.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsModel.h	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsModel.h	(revision 79842)
@@ -58,6 +58,4 @@
     /** Notifies listeners about model root item @a iMinimumWidthHint changed. */
     void sigRootItemMinimumWidthHintChanged(int iMinimumWidthHint);
-    /** Notifies listeners about model root item @a iMinimumHeightHint changed. */
-    void sigRootItemMinimumHeightHintChanged(int iMinimumHeightHint);
 
     /** Notifies listeners about element link clicked.
@@ -74,4 +72,7 @@
     /** Destructs a details model. */
     virtual ~UIDetailsModel() /* override */;
+
+    /** Inits model. */
+    void init();
 
     /** Returns graphics scene this model belongs to. */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsView.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsView.cpp	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsView.cpp	(revision 79842)
@@ -110,5 +110,4 @@
     , m_pDetails(pParent)
     , m_iMinimumWidthHint(0)
-    , m_iMinimumHeightHint(0)
 {
     /* Install Details-view accessibility interface factory: */
@@ -122,4 +121,5 @@
     /* Setup scroll-bars policy: */
     setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
+    setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
 
     /* Update scene-rect: */
@@ -148,19 +148,4 @@
 }
 
-void UIDetailsView::sltMinimumHeightHintChanged(int iMinimumHeightHint)
-{
-    /* Is there something changed? */
-    if (m_iMinimumHeightHint == iMinimumHeightHint)
-        return;
-
-    /* Remember new value: */
-    m_iMinimumHeightHint = iMinimumHeightHint;
-    if (m_iMinimumHeightHint <= 0)
-        m_iMinimumHeightHint = 1;
-
-    /* Update scene-rect: */
-    updateSceneRect();
-}
-
 void UIDetailsView::retranslateUi()
 {
@@ -177,9 +162,12 @@
     /* Notify listeners: */
     emit sigResized();
+
+    /* Update scene-rect: */
+    updateSceneRect();
 }
 
 void UIDetailsView::updateSceneRect()
 {
-    setSceneRect(0, 0, m_iMinimumWidthHint, m_iMinimumHeightHint);
+    setSceneRect(0, 0, m_iMinimumWidthHint, height());
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsView.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsView.h	(revision 79841)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsView.h	(revision 79842)
@@ -52,5 +52,4 @@
     /* Handlers: Size-hint stuff: */
     void sltMinimumWidthHintChanged(int iMinimumWidthHint);
-    void sltMinimumHeightHintChanged(int iMinimumHeightHint);
 
 private:
@@ -70,5 +69,4 @@
     /* Variables: */
     int m_iMinimumWidthHint;
-    int m_iMinimumHeightHint;
 };
 